
#ifdef __cplusplus
extern "C" {
#endif

#define SOFT_VER "00.06.05" // Update this number everytime we deliver a VM to the SOC
#define VEL_LABEL "VxVyVz"
#define REPR_LABEL "xyz"
#define QFLAG 2
// EAS data structure definition...
// struct EAS_data
// {
// 	double SCET[6], SCET_milli, SCET_seconds;
// 	double Data[16][32];
// 	double EnergyBinUsed;
	
// };

// struct PAS_data
// {
// 	double SCET[6], SCET_milli, SCET_seconds, Density, Velocity[3], Pressure[3][3];
// 	int SUM_PAS, PAS_DataValidity;
// 	unsigned int QUAL_Value, Qual_fill, qual_max, qual_min;
//         double fillvalue, maxepoch, Den_min, Den_max, Vel_min, Vel_max, Pres_min, Pres_max;
// };

struct HIS_data
{
	double SCET[6], SCET_milli, SCET_seconds, epoch;
	double Spectra1[64], Spectra2[64], Ratio1, Ratio2;
	unsigned int QUAL_Value, Qual_fill, qual_max, qual_min;
	unsigned int length;
	unsigned int structure_id;
	double fillvalue, maxepoch, maxscet, min_val, min_val_rat, value80000, value255, value32000, zero_t;
	double min_val_df, min_val_n, min_val_v, min_val_t, min_val_dferr, min_val_nerr;
	double max_val_df, max_val_n, max_val_v, max_val_t, max_val_dferr, max_val_nerr;
	double df1[64], df1_err[64], n1, n1_err, v1, t1;
	double df2[64], df2_err[64], n2, n2_err, v2, t2;
	double eqtab[64];
	char ratio1_str[12], ratio2_str[12], spectra1_str[20], spectra2_str[20];
	long epoch_fill;
};

// int read_EAS_data(char *, int, int, int);
// int read_PAS_data(char *, int, int);
int read_HIS_data(char *, int);
void processHisData(struct HIS_data *);
// int write_cdf_EAS (struct EAS_data *, struct EAS_data *, int , int, char *);
// int write_cdf_PAS (struct PAS_data *, int, char *);
int write_cdf_HIS (struct HIS_data [], int, char *);
void CurrentTime(unsigned long, char *, int);
void determineDate(unsigned long, char *);

#ifdef __cplusplus
}
#endif
