#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <limits>
#include <bitset>
#include <ctime>
#include <sstream>
#include "LL_global.h"

using namespace std;

/// function definitions ///
int hex2dec(char );
int hex2dec_2bytes(char *, int);
int hex2dec_2bytes(char *, int, int);
long int hex2dec_4bytes(char *, int);
//tm* convert2time(char * , int , char *);
tm* convert2time(unsigned long, char *);
void calculate_EAS_Etable(long, long, double *, int);
int hex2dec_3bytes(char *, int, int);
double HIS_Ratio(long);

int read_HIS_data(char *infile, int HIS_record_count)
{
   struct HIS_data HIS[300]; // Data structurs to hold Strahl data
   HIS_record_count = -1; // Initialize HIS record count to -1 every time this function is called...
//  Input binary file and file to contain output data
  //char *infile = argv[1];
  ifstream myfile (infile, ios::binary); // Input binary file
cout << "I am here..."<< endl;
  myfile.seekg (0, myfile.end); // Put the cursor at the end of file
  int file_length = myfile.tellg(); // get total number of bytes in the file
  
  //cout << file_length <<endl;
  myfile.seekg(0,myfile.beg); // Make sure the cursor is at the beginning of file before proceeding
  
  char stream[32], stream1[4500], SCET_str[80], SCET_str1[80], EAS_datestring[80];
  int header[7], advance, SCET_milli, SCET_year, SCET_month, SCET_mday,
      SCET_hour, SCET_minute, SCET_second;
  tm* SCET_ymdhms;
  long int SCET_ymdhms1, SCET_milli1;
  long int SCET_epoch_milli, SCET_epoch_milli1, SCET_first_eas1, SCET_last_eas1, SCET_first_eas2, SCET_last_eas2;
  long SCET_first, SCET_last, scet_cnt=0;

cout << endl << " Reading in HIS low latency data..." << endl;
/* ------ Main "do-while" loop to read data from input file Starts ----*/
  do { // Start main loop to look through all data in the input file
     myfile.read(stream,32);
////////////////////////////////////////////////////////////////////////////////////////////
//   Extracting Header info PID, CAT(PKC), PL, ST, SS, SID
////////////////////////////////////////////////////////////////////////////////////////////
   std::bitset<7> PID;
   std::bitset<4> PKC;
   bool is_set1;
   for(int i = 2; i >=0; i--){
     is_set1 = (stream[0] >> i) & 1;
     PID.set((i+4), is_set1);
   }
   for(int i = 7; i >=4; i--){
     is_set1 = (stream[1] >> i) & 1;
     PID.set((i-4), is_set1);
   } 
   for(int i = 3; i >=0; i--){
     is_set1 = (stream[1] >> i) & 1;
     PKC.set((i), is_set1);
   }
   
   header[0] = PID.to_ulong(); // Contains PID
   header[1] = PKC.to_ulong(); // Contains CAT
   header[2] = hex2dec_2bytes(stream, 4); // contains packet length (PL)
   header[3] = hex2dec(stream[7]); //contains Service Type (ST)
   header[4] = hex2dec(stream[8]); //contains Service SubType (SS)
   if(header[3] == 5 && header[4] == 2){
      header[5] = hex2dec_2bytes(stream,16); // contains SID
   }
   else
   {
      header[5] = hex2dec(stream[16]); // contains SID
   }
   header[6] = 0;
   header[6] = hex2dec_2bytes(stream, 18); // SID counter

   int go_back = -26; // put the cursor just after the packet length word.
   myfile.seekg(go_back,ios_base::cur);
   advance = header[2] + 1;
   //cout << header[3] << "  " << header[4] << "  " << header[5] << endl;
//-----------------------Start of getting EAS1 Strahl data into EAS1_Strahl_data structure  -----------------------------------//
       if(header[3] == 21 && header[4] == 6 && (header[5] == 132 || header[5] == 133 || header[5] == 134)) // Get Information from the header packet, ST = 21, SS = 3 and SID = 0
       {
           myfile.read(stream1, advance);
	   HIS_record_count++;
	   if(HIS_record_count == 0) { cout << " Reading in HIS Spectra packets from input file " << endl; }
	   
	   
	   SCET_ymdhms1 = hex2dec_4bytes(stream, 10);
           SCET_milli = (hex2dec_2bytes(stream, 14) / 65535.0) * 1000;  // Get EAS time tag milli-seconds at the observation
	   SCET_epoch_milli1 = SCET_ymdhms1 + SCET_milli;
	   
	   // Values for CDF file constants...
	   HIS[0].Qual_fill = 255; // initialize quality fillvalue
	   HIS[0].qual_min = 0; // quality flag min
	   HIS[0].qual_max = 4; // quality flag max
	   HIS[0].QUAL_Value = 2; //Quality flag hardwired
	   HIS[0].fillvalue = -1E+31;
	   HIS[0].maxepoch = 4294967295.999;
	   HIS[0].min_val = 0.1;
	   HIS[0].min_val_rat = 1E-4;
	   HIS[0].value80000 = 80000.0;
	   HIS[0].value255 = 255.0;
	   HIS[0].value32000 = 32000.0;
	   HIS[0].zero_t = 0.0;
	   HIS[0].min_val_df = 1E-20;
	   HIS[0].min_val_dferr = 1E-20;
	   HIS[0].min_val_n = 1E-3;
	   HIS[0].min_val_nerr = 1E-3;
	   HIS[0].min_val_v = 100;
	   HIS[0].min_val_t = 12000;
	   HIS[0].max_val_df = 1;
	   HIS[0].max_val_dferr = 1;
	   HIS[0].max_val_n = 1E3;
	   HIS[0].max_val_nerr = 1E3;
	   HIS[0].max_val_v = 3000;
	   HIS[0].max_val_t = 3000000;

	   SCET_ymdhms = convert2time(SCET_ymdhms1, SCET_str);
	   SCET_epoch_milli = SCET_milli;  // Get PAS time tag milli-seconds at the observation
	   //cout << endl << " SCET_str is: " << SCET_str << endl << endl;
	   //cout << SCET_ymdhms->tm_year << "-"  << SCET_ymdhms->tm_mon << "-" << SCET_ymdhms->tm_mday << "T" << SCET_ymdhms->tm_hour << ":" << SCET_ymdhms->tm_min << ":" << SCET_ymdhms->tm_min << endl;
	   SCET_year    =  (SCET_ymdhms->tm_year) + 1900;
	   SCET_month   =  (SCET_ymdhms->tm_mon) + 1;
	   SCET_mday    =  SCET_ymdhms->tm_mday;
	   SCET_hour    =  SCET_ymdhms->tm_hour;
	   SCET_minute  =  SCET_ymdhms->tm_min;
	   SCET_second  =  SCET_ymdhms->tm_sec;
				
	   if (scet_cnt == 0) { SCET_first = SCET_ymdhms1; scet_cnt = 1;}
	   SCET_last = SCET_ymdhms1;
	   //cout << SCET_str << "   " << SCTime_epoch << "    -----    " << SCET_year << SCET_month << SCET_mday << "T" << SCET_hour << ":" << SCET_minute << ":" << SCET_second << endl;
	   HIS[HIS_record_count].SCET[0] = SCET_year;
	   HIS[HIS_record_count].SCET[1] = SCET_month;
	   HIS[HIS_record_count].SCET[2] = SCET_mday;
	   HIS[HIS_record_count].SCET[3] = SCET_hour;
	   HIS[HIS_record_count].SCET[4] = SCET_minute;
	   HIS[HIS_record_count].SCET[5] = SCET_second;
	   HIS[HIS_record_count].SCET_milli = 0;
	   HIS[HIS_record_count].SCET_seconds = SCET_epoch_milli1;
	   //cout << HIS[HIS_record_count].SCET_seconds << " -- ";
	   // 
	   // NOTE: HIS time may need changing to take "Time Whole" mentioned in HIS_LL sheet of HIS_TLM.xlsx file.
	   //
	   long ratio1, ratio2;
	   ratio1 = hex2dec_3bytes(stream1, 13, 0);
	   ratio2 = hex2dec_3bytes(stream1, 16, 0);
	   HIS[HIS_record_count].Ratio1 = HIS_Ratio(ratio1);
	   HIS[HIS_record_count].Ratio2 = HIS_Ratio(ratio2);
	   
	   //cout << HIS[HIS_record_count].Ratio1 << "  " << HIS[HIS_record_count].Ratio2 << "  ";
	   int spectra_length = (header[2] - 19) / 2;
	   int st1 = 17;
	   int st2 = st1 + spectra_length;
	   
	   for(int si = 0; si < spectra_length; si++)
	   {
		st1 = st1 + 2;
		st2 = st2 + 2;
		HIS[HIS_record_count].Spectra1[si] = hex2dec(stream1[st1]);
		HIS[HIS_record_count].Spectra2[si] = hex2dec(stream1[st2]);
		//cout << hex << HIS[HIS_record_count].Spectra2[si] << "  ";// << HIS[HIS_record_count].Spectra2[si] << "  ";
	   }
	   //cout << endl;
	   
	   advance = 0;
       }
//-----------------------End of getting EAS2 Strahl data into EAS2_Strahl_data structure  -------------------------------------//

    myfile.ignore(advance);
  }while ((myfile.tellg() < file_length) && myfile.tellg() != -1);
// ------ Main "do-while" loop to read data from input file Ends ----//
  
myfile.close();

	// Make the datetime for the file name:

	for(int i = 0; i <= HIS_record_count; i++) {
		processHisData(&HIS[HIS_record_count]);
	}

	stringstream datetime_stream;
	datetime_stream << setw(10) << setfill('0') << SCET_first << "-" << setw(10) << setfill('0') << SCET_last;
	datetime_stream >> SCET_str1;

	cout << "Processed " << (HIS_record_count+1) <<  " HIS Spectra (LL) Packets... " << endl;
	// Write CDF file - Pass PAS data structure to the CDF writer functions
	if(HIS_record_count != -1)
	{
		cout << " Writing HIS cdf file...\n";
		write_cdf_HIS (HIS, HIS_record_count, SCET_str1);
	}
	else
	{
		ofstream HIS_log("HIS_failed", ios::out | ios::app);
		if(HIS_record_count == -1) HIS_log << " There are no HIS Low Latency data packets in the input file. Aborting making HIS CDF file! Input file is: " << infile << endl;
	}    

}//// End of Main ///

//// Functions used in these codes ////

double HIS_Ratio(long value_3bytes)
{
	bitset<20> ratio_int;
	bitset<4>  ratio_exp;
	bool is_set;
	double Ratio;
	int expo_int;
	
	for(int k = 23; k > 19; k--)
	{
		is_set = (value_3bytes >> k) & 1;
		ratio_exp.set((k-20),is_set);
	}
	
	for(int k = 19; k >=0; k--)
	{
		is_set = (value_3bytes >> k ) & 1;
		ratio_int.set(k,is_set);
	}
	
	expo_int = ratio_exp.to_ulong() * -1;
	
	if(ratio_int.to_ulong() != 0)
	{
	      Ratio = ratio_int.to_ulong() * pow(10,expo_int);
	}
	else
	{
	      Ratio = 0;
	}
//	cout << "--------   " << ratio_int.to_ulong() << "   " << ratio_exp.to_ulong() << "   " << Ratio << endl;
    return Ratio;
	
}

int hex2dec(char HexNum)
{
       int result = 0;
       bool is_set = 0;
       for(int i = 7; i >=0; i--){
	 is_set = (HexNum >> i) & 1;
	 result += is_set * pow(2,i);
	}
       return result;
}
int hex2dec_2bytes(char * HexN, int st)
{
       int res1 = 0, res2 = 0, result;
       int sp = st + 1;
       bool is_set = 0;
       //cout << "  " << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << ((unsigned) HexN[st] & 0xFF);
       //cout << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << ((unsigned) HexN[sp] & 0xFF);
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[st] >> i) & 1;
	 res1 += is_set * pow(2,i+8);
	}
	for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i);
	} 
       return result = res2 + res1; 
}

// This function is to use with converting decompressed data to decimal as this has different endian.
int hex2dec_2bytes(char * HexN, int st, int flg)
{
       int res1 = 0, res2 = 0, result;
       int sp = st + 1;
       bool is_set = 0;
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[st] >> i) & 1;
	 res1 += is_set * pow(2,i);
	}
	for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i+8);
	} 
        result = res2 + res1;
	return  result;
}
// This function is to use with converting decompressed data to decimal as this has different endian.
int hex2dec_3bytes(char * HexN, int st, int flag)
{
       int res1 = 0, res2 = 0, res3 = 0, result;
       int sp = st + 1;
       int sp1 = sp + 1;
       bool is_set = 0;
       //cout << "  " << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << ((unsigned) HexN[st] & 0xFF);
       //cout << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << ((unsigned) HexN[sp] & 0xFF);
if(flag == 0)
{
         for(int i = 7; i >=0; i--){
	 is_set = (HexN[st] >> i) & 1;
	 res1 += is_set * pow(2,i+16);
        }
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i+8);
	}
	for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp1] >> i) & 1;
	 res3 += is_set * pow(2,i);
	}
}
else
{
        int x = 0; 
	for(int i = 7; i >=4; i--){
	 is_set = (HexN[st] >> i) & 1;
	 x= i - 4;
	 res1 += is_set * pow(2,x+16);
        }
         for(int i = 3; i >=0; i--){
	 is_set = (HexN[st] >> i) & 1;
	 x = i + 4;
	 res1 += is_set * pow(2,x+8);
        }
       for(int i = 7; i >=4; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 x = i - 4;
	 res2 += is_set * pow(2,x+8);
	}
       for(int i = 3; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 x = i + 4;
	 res2 += is_set * pow(2,x);
	}
	for(int i = 7; i >=4; i--){
	 is_set = (HexN[sp1] >> i) & 1;
	 x = i - 4;
	 res3 += is_set * pow(2,x);
	}
	
}
       return result = res3 + res2 + res1; 
}

// Get 4-bytes at a time as long integer
long int hex2dec_4bytes(char * HexN, int st)
{
       long int res1 = 0, res2 = 0, res3 = 0, res4 = 0, result;
       int sp = st + 1;
       bool is_set = 0;
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[st] >> i) & 1;
	 res1 += is_set * pow(2,i+24);
       }
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i+16);
       }
       sp++;
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i+8);
       }
       sp++;
       for(int i = 7; i >=0; i--){
	 is_set = (HexN[sp] >> i) & 1;
	 res2 += is_set * pow(2,i);
       } 
       return result = res1 + res2 + res3 + res4; 
}

/////
tm* convert2time(unsigned long SCET_long, char * time_str)
{
   long SC_time_epoch = SCET_long;// + 946598400;//1199142000; // added epoch for 2000-01-01 in GMT.
   std::time_t SC_time_epoch1 = static_cast<time_t>(SC_time_epoch);
   strftime(time_str,80,"%Y%m%d",std::localtime(&SC_time_epoch1));
   tm* timePtr = localtime(&SC_time_epoch1);
   return timePtr;
}
