#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <cdf.h>
#include <LL_global.h>

/******************************************************************************
* Function prototypes.
******************************************************************************/

int StatusHandler (CDFstatus status);

/******************************************************************************
* MAIN.
******************************************************************************/
int write_cdf_HIS (struct HIS_data *HIS_struct, int HIS_Num_Records, char *DataDate)
{
  long ii = 0;
  // for(ii = 0; ii < HIS_Num_Records; ii++) // Write HIS data to CDF file
  //  {
  //    //SCET_Epoch = computeEPOCH(HIS_struct[ii].SCET[0], HIS_struct[ii].SCET[1], HIS_struct[ii].SCET[2],
  //    //                  HIS_struct[ii].SCET[3], HIS_struct[ii].SCET[4], HIS_struct[ii].SCET[5],HIS_struct[ii].SCET_milli);
  //    printf("%f\n", HIS_struct[0].eqtab[63]);
  //    printf("%f\n", HIS_struct[0].Spectra1[63]);
  //    printf("%f\n", HIS_struct[0].Spectra2[55]);      
  //    printf("%f\n", HIS_struct[0].Spectra2[56]);
  //    printf("a%sa\n", HIS_struct[0].spectra1_str);

  //  }
     //printf("%i\n%i\n%i\n", sizeof(*HIS_struct), sizeof(HIS_struct[0]), sizeof(HIS_struct[0].eqtab));

  // Create the CDF file
  CDFid  file_id;    // CDF identifier
  CDFstatus status;  // CDF completion status
  char *gAttr[] = {"SOLO>Solar Orbiter",
		   "Cosmic Visions",
		   "SOLO>Solar Orbiter",
                   "Space Physics>Interplanetary Studies",
                   "LL01>Level 1 Low Latency Data",
                   "SWA-HIS-RAT",
		   "01",
		   "01.00.00",
		   "C. J. Owen",
                   "MSSL-UCL, University College London, UK",
       "Low Latency Data for HIS instrument",
		   "Plasma and Solar Wind",
                   "Solar Orbiter",
	           "solo_ll01_swa-his-rat",
		   "solo_ll01_swa-his-rat_20180101_V01",
		   "SWA-HIS Ratios and Spectra",
		   "Consult with MSSL-UCL before using",
		   "Solar Orbiter SOC, ESAC",
		   "2018-08-16T14:00:00Z",
		   "V01 First Version",
		   "RAT>HIS Ratios and Spectra",
		   "LL01>Level 1 Low Latency Data",
		   "SWA-HIS>Solar Wind Analyser-Heavy Ion Sensor",
       "source_descriptor_datatype_yyyMMdd"}; // Global Attributes
  long gAttrNum[24], zVarAttrNum[19]; // Global Attribute numbers and Variable attribute numbers
  long HIS_EPOCH_num, HIS_SCET_num, HIS_Ratio1_num, HIS_Ratio2_num, HIS_Spectra1_num, HIS_Spectra2_num, HIS_Ene_array_num, 
       HIS_Ratio1_Species_num, HIS_Ratio2_Species_num, HIS_Species1_num, HIS_Species2_num, HIS_Quality_num,
       HIS_df1_num, HIS_dferror1_num, HIS_n1_num, HIS_nerr1_num, HIS_v1_num, HIS_t1_num, 
       HIS_df2_num, HIS_dferror2_num, HIS_n2_num, HIS_nerr2_num, HIS_v2_num, HIS_t2_num, HIS_QualityMask_num;
  
  static long EPOCHdimSizes[1] = {3}, Data_DimSizes[1] = {64}, Ratio_DimSizes[1] = {1}, RatioSpecies_StringSizes[1] = {12}, SpectrumSpecies_StringSizes[1] = {20};
  static long Data_DimVary[2] = {VARY, VARY}, Species_vary[1] = {VARY}, Data_DimNovary[2] = {NOVARY, NOVARY};
  
  char HIS_Ratio1_Str[12], HIS_Ratio2_Str[12], HIS_Spectra1_Str[20], HIS_Spectra2_Str[20];
  
// Get Current Time
   time_t result = time(0);
   unsigned long result_ulong = result;
   char Curr_Time_str[80], Curr_Date_Str[80];
   CurrentTime(result_ulong, Curr_Time_str, 1);
   CurrentTime(result_ulong, Curr_Date_Str, 2);
   //determineDate(HIS_struct[0].SCET_seconds, Curr_Date_Str);
   gAttr[17] = Curr_Time_str;

/* default values...   */
   int zero = 0;
   //unsigned int quality_flag_value = 2, scale_max_quality = 4, scale_min_quality = 0, qual_fill = 255;

// Construt LogicalFileId and CDF file name
   char LogicalFileId[38] = "solo_ll01_swa-his-rat_";
   //strcat(LogicalFileId, Curr_Date_Str);
   strcat(LogicalFileId, DataDate);
  //printf("%s", LogicalFileId);

// Construt CDF file name
   char cdfFile[80];
   strcpy(cdfFile, LogicalFileId);
   strcat(cdfFile, Curr_Date_Str);
   if(HIS_Num_Records >= 270)
   {
	strcat(cdfFile, "C");
   }
   else
   {
	strcat(cdfFile, "I");
   }
   strcpy(LogicalFileId, cdfFile);
   //strcat(LogicalFileId, "_V01");
   gAttr[13] = LogicalFileId;
   gAttr[7] = SOFT_VER; // Read Software version from LL_global.h
   strcat(cdfFile, ".cdf");
  printf("HIS file name: %s\n", cdfFile);
  /******************************************************************************  
  * Create the CDF.
  ******************************************************************************/
  //status = CDFcreateCDF("solo_LL01_swa-his-lldata_20180101_V01_20180816.cdf", &file_id);
  printf("Creating CDF File and setting column majority...\n");
  status = CDFcreateCDF(cdfFile, &file_id);
  if (status != CDF_OK) StatusHandler (status);

  status = CDFsetMajority(file_id, COLUMN_MAJOR);
  if (status != CDF_OK) StatusHandler (status);


  printf("Creating global variables...\n");

// Create global attributes ...
  status = CDFcreateAttr(file_id,"Project",GLOBAL_SCOPE,&gAttrNum[0]);
  if(status != CDF_OK) StatusHandler (status);
    
  status = CDFcreateAttr(file_id,"Source_name",GLOBAL_SCOPE,&gAttrNum[1]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Discipline",GLOBAL_SCOPE,&gAttrNum[2]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Data_type",GLOBAL_SCOPE,&gAttrNum[3]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Descriptor",GLOBAL_SCOPE,&gAttrNum[4]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Data_version",GLOBAL_SCOPE,&gAttrNum[5]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Software_version",GLOBAL_SCOPE,&gAttrNum[6]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"PI_name",GLOBAL_SCOPE,&gAttrNum[7]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"PI_affiliation",GLOBAL_SCOPE,&gAttrNum[8]);
  if(status != CDF_OK) StatusHandler (status);

  status = CDFcreateAttr(file_id,"TEXT",GLOBAL_SCOPE,&gAttrNum[9]);
  if(status != CDF_OK) StatusHandler (status);

  status = CDFcreateAttr(file_id,"Instrument_type",GLOBAL_SCOPE,&gAttrNum[10]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Mission_group",GLOBAL_SCOPE,&gAttrNum[11]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Logical_source",GLOBAL_SCOPE,&gAttrNum[12]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Logical_file_id",GLOBAL_SCOPE,&gAttrNum[13]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Logical_source_description",GLOBAL_SCOPE,&gAttrNum[14]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Rules_of_use",GLOBAL_SCOPE,&gAttrNum[15]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Generated_by",GLOBAL_SCOPE,&gAttrNum[16]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Generation_date",GLOBAL_SCOPE,&gAttrNum[17]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"MODS",GLOBAL_SCOPE,&gAttrNum[18]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Data_Product",GLOBAL_SCOPE,&gAttrNum[19]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"LEVEL",GLOBAL_SCOPE,&gAttrNum[20]);
  if(status != CDF_OK) StatusHandler (status);
	     
  status = CDFcreateAttr(file_id,"Instrument",GLOBAL_SCOPE,&gAttrNum[21]);
  if(status != CDF_OK) StatusHandler (status);

  status = CDFcreateAttr(file_id,"spase_DatasetResourceID",GLOBAL_SCOPE,&gAttrNum[22]);
  if(status != CDF_OK) StatusHandler (status);

  status = CDFcreateAttr(file_id,"File_naming_convention",GLOBAL_SCOPE,&gAttrNum[23]);
  if(status != CDF_OK) StatusHandler (status);


  printf("Writing global attributes...\n");

// Write Global attributes 'gEntry' for all Global attributes
  status = CDFputAttrgEntry(file_id, gAttrNum[0], 0L, CDF_CHAR, strlen(gAttr[0]), gAttr[0]); // entry for Project
  if(status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[0], 1L, CDF_CHAR, strlen(gAttr[1]), gAttr[1]); // entry for Project
  if(status != CDF_OK) StatusHandler (status);
  
  status = CDFputAttrgEntry(file_id, gAttrNum[1], 0L, CDF_CHAR, strlen(gAttr[2]), gAttr[2]); // entry for Source_name
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[2], 0L, CDF_CHAR, strlen(gAttr[3]), gAttr[3]); // entry for Descipline
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[3], 0L, CDF_CHAR, strlen(gAttr[4]), gAttr[4]); // entry for Data_type
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[4], 0L, CDF_CHAR, strlen(gAttr[5]), gAttr[5]); // entry for Descriptor
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[5], 0L, CDF_CHAR, strlen(gAttr[6]), gAttr[6]); // entry for Data_version
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[6], 0L, CDF_CHAR, strlen(gAttr[7]), gAttr[7]); // entry for Software_version
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[7], 0L, CDF_CHAR, strlen(gAttr[8]), gAttr[8]); // entry for PI_name
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[8], 0L, CDF_CHAR, strlen(gAttr[9]), gAttr[9]); // entry for PI_affiliation
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[9], 0L, CDF_CHAR, strlen(gAttr[10]), gAttr[10]); // entry for TEXT
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[10], 0L, CDF_CHAR, strlen(gAttr[11]), gAttr[11]); // entry for Instrument_type
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[11], 0L, CDF_CHAR, strlen(gAttr[12]), gAttr[12]); // entry for Mission_group
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[12], 0L, CDF_CHAR, strlen(gAttr[13]), gAttr[13]); // entry for Logical_source
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[13], 0L, CDF_CHAR, strlen(gAttr[14]), gAttr[14]); // entry for Logical_file_id
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[14], 0L, CDF_CHAR, strlen(gAttr[15]), gAttr[15]); // entry for Logical_source_description
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[15], 0L, CDF_CHAR, strlen(gAttr[16]), gAttr[16]); // entry for Rules_of_use
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[16], 0L, CDF_CHAR, strlen(gAttr[17]), gAttr[17]); // entry for Generated_by
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[17], 0L, CDF_CHAR, strlen(gAttr[18]), gAttr[18]); // entry for Generation_date
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[18], 0L, CDF_CHAR, strlen(gAttr[19]), gAttr[19]); // entry for MODS
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[19], 0L, CDF_CHAR, strlen(gAttr[20]), gAttr[20]); // entry for Data_product
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[20], 0L, CDF_CHAR, strlen(gAttr[21]), gAttr[21]); // entry for Level
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[21], 0L, CDF_CHAR, strlen(gAttr[22]), gAttr[22]); // entry for Instrument
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[22], 0L, CDF_CHAR, 1, " "); // spase dataset resource id
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrgEntry(file_id, gAttrNum[23], 0L, CDF_CHAR, strlen(gAttr[23]), gAttr[23]); // entry for file naming convention
  if (status != CDF_OK) StatusHandler (status);


  printf("Creating z variables...\n");

// Create zVariables
  status = CDFcreatezVar (file_id, "Epoch", CDF_TIME_TT2000, 1L, 0L, EPOCHdimSizes, VARY, VARY, &HIS_EPOCH_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SCET", CDF_REAL8, 1L, 0L, EPOCHdimSizes, VARY, VARY, &HIS_SCET_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_ENERGY_PER_CHARGE", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_Ene_array_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_SPECTRUM1", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_Spectra1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_SPECTRUM2", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_Spectra2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_RATIO1", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_Ratio1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_RATIO2", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_Ratio2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_SPECIES1", CDF_CHAR, 20L, 0L, Ratio_DimSizes, VARY, Species_vary, &HIS_Species1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_SPECIES2", CDF_CHAR, 20L, 0L, Ratio_DimSizes, VARY, Species_vary, &HIS_Species2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_RATIO1_SPECIES", CDF_CHAR, 12L, 0L, Ratio_DimSizes, VARY, Species_vary, &HIS_Ratio1_Species_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_RATIO2_SPECIES", CDF_CHAR, 12L, 0L, Ratio_DimSizes, VARY, Species_vary, &HIS_Ratio2_Species_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "QUALITY_FLAG", CDF_UINT1, 1L, 0L, EPOCHdimSizes, VARY, NOVARY, &HIS_Quality_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "QUALITY_BITMASK", CDF_UINT1, 1L, 0L, EPOCHdimSizes, VARY, NOVARY, &HIS_QualityMask_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_DIFF_FLUX1", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_df1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_DIFF_FLUX1_ERROR", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_dferror1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_N1", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_n1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_N1_ERROR", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_nerr1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_V1", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_v1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_T1", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_t1_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_DIFF_FLUX2", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_df2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_DIFF_FLUX2_ERROR", CDF_REAL8, 1L, 1L, Data_DimSizes, VARY, Data_DimVary, &HIS_dferror2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_N2", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_n2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_N2_ERROR", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_nerr2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_V2", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_v2_num);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreatezVar (file_id, "SWA_HIS_T2", CDF_REAL8, 1L, 0L, Ratio_DimSizes, VARY, Data_DimVary, &HIS_t2_num);
  if (status != CDF_OK) StatusHandler (status);

  printf("Creating z variable attributes...\n");

// Create Variable attributes...
  status = CDFcreateAttr(file_id,"FIELDNAM",VARIABLE_SCOPE,&zVarAttrNum[0]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"CATDESC",VARIABLE_SCOPE,&zVarAttrNum[1]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"DISPLAY_TYPE",VARIABLE_SCOPE,&zVarAttrNum[2]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"FILLVAL",VARIABLE_SCOPE,&zVarAttrNum[3]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"FORMAT",VARIABLE_SCOPE,&zVarAttrNum[4]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"LABLAXIS",VARIABLE_SCOPE,&zVarAttrNum[5]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"UNITS",VARIABLE_SCOPE,&zVarAttrNum[6]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"VALIDMIN",VARIABLE_SCOPE,&zVarAttrNum[7]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"VALIDMAX",VARIABLE_SCOPE,&zVarAttrNum[8]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"SCALETYP",VARIABLE_SCOPE,&zVarAttrNum[11]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"SCALEMIN",VARIABLE_SCOPE,&zVarAttrNum[9]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"SCALEMAX",VARIABLE_SCOPE,&zVarAttrNum[10]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"DEPEND_0",VARIABLE_SCOPE,&zVarAttrNum[12]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"DEPEND_1",VARIABLE_SCOPE,&zVarAttrNum[13]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"VAR_TYPE",VARIABLE_SCOPE,&zVarAttrNum[14]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"VAR_NOTES",VARIABLE_SCOPE,&zVarAttrNum[15]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"SI_CONVERSION",VARIABLE_SCOPE,&zVarAttrNum[16]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"TIME_BASE",VARIABLE_SCOPE,&zVarAttrNum[17]);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFcreateAttr(file_id,"TIME_SCALE",VARIABLE_SCOPE,&zVarAttrNum[17]);
  if (status != CDF_OK) StatusHandler (status);
  
// setting up time variable
// timebase and timescale
  printf("Creating time variable base and scale...\n");
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "TIME_BASE"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 6L, "SS2000");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "TIME_SCALE"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 16L, "Terrestrial Time");
  if (status != CDF_OK) StatusHandler (status);


  printf("Creating z variable fieldnams...\n");

// Put zVariable attribute values
  // FIELDNAM Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 4L, "SCET");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 6L, "Ratio1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 6L, "Ratio2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 8L, "Spectra1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 8L, "Spectra2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 33L, "HIS energy per charge (E/q) table");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 49L, "HIS ion species associated with SWA_HIS_Spectrum1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 49L, "HIS ion species associated with SWA_HIS_Spectrum2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 46L, "HIS ion species associated with SWA_HIS_Ratio1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 46L, "HIS ion species associated with SWA_HIS_Ratio2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 30L, "HIS Ratios and Spectra Quality");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 39L, "HIS Ratios and Spectra Quality Bit Mask");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 48L, "HIS Diff. Flux associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 54L, "HIS Diff. Flux error associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 45L, "HIS Density associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 51L, "HIS Density Error associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 46L, "HIS Velocity associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 49L, "HIS Temperature associated with SWA_HIS_SPECTRUM1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 48L, "HIS Diff. Flux associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 54L, "HIS Diff. Flux error associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 45L, "HIS Density associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 51L, "HIS Density Error associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 46L, "HIS Velocity associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FIELDNAM"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 49L, "HIS Temperature associated with SWA_HIS_SPECTRUM2");
  if (status != CDF_OK) StatusHandler (status);

  printf("Creating z variable catdesc...\n");

  // CATDESC Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 33L, "Elapsed time of the onboard clock");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 33L, "Elapsed time of the onboard clock");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 36L, "The ratio between 2 species from HIS");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 36L, "The ratio between 2 species from HIS");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 24L, "Spectrum 1 data from HIS");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 24L, "Spectrum 2 data from HIS");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 33L, "HIS energy per charge (E/q) table");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 45L, "Ion species used to get the spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 45L, "Ion species used to get the spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 34L, "Ion species used to get the Ratio1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 34L, "Ion species used to get the Ratio2");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 35L, "HIS Ratios and Spectra Quality flag");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 39L, "HIS Ratios and Spectra Quality bit mask");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 51L, "Differential Flux calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 57L, "Differential Flux Error calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 41L, "Density calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 47L, "Density error calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 42L, "Velocity calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 45L, "Temperature calculated from spectrum1 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 51L, "Differential Flux calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 57L, "Differential Flux Error calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 41L, "Density calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 47L, "Density error calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 42L, "Velocity calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "CATDESC"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 45L, "Temperature calculated from spectrum2 spectra");
  if (status != CDF_OK) StatusHandler (status);

  printf("Creating z variable display type...\n");

  // DISPLAY_TYPE Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 11L, "spectrogram");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 11L, "spectrogram");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 11L, "spectrogram");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 11L, "spectrogram");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DISPLAY_TYPE"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 11L, "time_series");
  if (status != CDF_OK) StatusHandler (status);
    
  printf("Creating z variable fillval...\n");

  // FILLVAL Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SCET"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "Epoch"), CDF_TIME_TT2000, 1L, &HIS_struct[0].epoch_fill);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_UINT1, 1L, &HIS_struct[0].Qual_fill);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_UINT1, 1L, &HIS_struct[0].Qual_fill);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FILLVAL"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_REAL8, 1L, &HIS_struct[0].fillvalue);
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable formats...\n");

  // FORMAT Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 5L, "f20.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 3L, "A15");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 3L, "A15");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 3L, "A12");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 3L, "A12");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 5L, "f14.4");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 2L, "I3");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "FORMAT"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 2L, "I5");
  if (status != CDF_OK) StatusHandler (status);

  printf("Creating z variable lablaxis...\n");  

  // LABLAXIS Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 5L, "EPOCH");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 23L, "Spacecraft Elapsed Time");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 25L, "Ratio between two species");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 25L, "Ratio between two species");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 6L, "Counts");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 6L, "Counts");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 6L, "Energy");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 12L, "Quality flag");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 19L, "Differential Flux");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 19L, "Differential Flux");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 7L, "Density");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 7L, "Density");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 8L, "Velocity");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 8L, "Velocity");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 11L, "Temperature");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 11L, "Temperature");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 14L, "Relative Error");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 14L, "Relative Error");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "LABLAXIS"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 1L, " ");
  printf("Creating z variable units...\n");
  
  // UNITS Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 2L, "ns");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 12L, "milliseconds");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 6L, "Counts");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 6L, "Counts");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 5L, "KeV/e");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 18L, "(cm^2 s sr keV)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 18L, "(cm^2 s sr keV)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 9L, "(cm^3)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 9L, "(cm^3)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 7L, "km s^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 7L, "km s^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 1L, "K");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 1L, "K");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "UNITS"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 1L, " ");
  if (status != CDF_OK) StatusHandler (status);


  printf("Creating z variable validmins...\n");

  // VALIDMIN Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "Epoch"), CDF_TIME_TT2000, 1L, 0);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SCET"), CDF_REAL8, 1L, 0);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_rat);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_rat);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_UINT1, 1L, &HIS_struct[0].qual_min);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_UINT1, 1L, &HIS_struct[0].qual_min);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_t);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMIN"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_t);
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable validmaxs...\n");
 
  // VALIDMAX Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "Epoch"), CDF_TIME_TT2000, 1L, &HIS_struct[0].maxepoch); // seconds since epoch till year 2040-Jan-01 00:00:00
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SCET"), CDF_REAL8, 1L, &HIS_struct[0].maxscet); // seconds since epoch till year 2040-Jan-01 00:00:00
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_REAL8, 1L, &HIS_struct[0].value32000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_REAL8, 1L, &HIS_struct[0].value32000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_REAL8, 1L, &HIS_struct[0].value255);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_REAL8, 1L, &HIS_struct[0].value255);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_REAL8, 1L, &HIS_struct[0].value80000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_UINT1, 1L, &HIS_struct[0].qual_max);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_UINT1, 1L, &HIS_struct[0].qual_max);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_t);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VALIDMAX"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_t);
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable scalemins...\n");

  // SCALEMIN Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "Epoch"), CDF_TIME_TT2000, 1L, 0);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SCET"), CDF_REAL8, 1L, 0);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_rat);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_rat);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_REAL8, 1L, &HIS_struct[0].min_val);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_UINT1, 1L, &HIS_struct[0].qual_min);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_UINT1, 1L, &HIS_struct[0].qual_min);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_t);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_REAL8, 1L, &HIS_struct[0].min_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].min_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMIN"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_REAL8, 1L, &HIS_struct[0].min_val_t);
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable scalemaxs...\n");
   
  // SCALEMAX Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "Epoch"), CDF_TIME_TT2000, 1L, &HIS_struct[0].maxepoch); // seconds since epoch till year 2040-Jan-01 00:00:00
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SCET"), CDF_REAL8, 1L, &HIS_struct[0].maxscet); // seconds since epoch till year 2040-Jan-01 00:00:00
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_REAL8, 1L, &HIS_struct[0].value32000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_REAL8, 1L, &HIS_struct[0].value32000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_REAL8, 1L, &HIS_struct[0].value255);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_REAL8, 1L, &HIS_struct[0].value255);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_REAL8, 1L, &HIS_struct[0].value80000);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_UINT1, 1L, &HIS_struct[0].qual_max);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_UINT1, 1L, &HIS_struct[0].qual_max);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_t);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_REAL8, 1L, &HIS_struct[0].max_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_df);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_dferr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_n);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_REAL8, 1L, &HIS_struct[0].max_val_nerr);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_v);
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALEMAX"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_REAL8, 1L, &HIS_struct[0].max_val_t);
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable scaletyps...\n");
  
  // SCALETYP Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 3L, "log");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SCALETYP"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 6L, "linear");
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable depend 0s...\n");
  
// DEPEND_0 Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_0"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 5L, "Epoch");
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable depend 1s...\n");

  // DEPEND_1 Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "DEPEND_1"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 25L, "SWA_HIS_ENERGY_PER_CHARGE");
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable var_types...\n");

  // VAR_TYPE Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "Epoch"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SCET"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECTRUM2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECIES1"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_SPECIES2"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO1_SPECIES"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_RATIO2_SPECIES"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "QUALITY_FLAG"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "QUALITY_BITMASK"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1_ERROR"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_N1_ERROR"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_T1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2_ERROR"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_N2_ERROR"), CDF_CHAR, 12L, "support_data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "VAR_TYPE"), CDFvarNum(file_id, "SWA_HIS_T2"), CDF_CHAR, 4L, "data");
  if (status != CDF_OK) StatusHandler (status);
  
  printf("Creating z variable conversions...\n");

  // SI_CONVERSION Attribute
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_ENERGY_PER_CHARGE"), CDF_CHAR, 10L, "1.0E+3>J/C");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX1"), CDF_CHAR, 24L, "1.0E+4>(m^2 s sr keV)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_N1"), CDF_CHAR, 15L, "1.0E+6>(m^3)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_V1"), CDF_CHAR, 13L, "1.0E+3>m s^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_DIFF_FLUX2"), CDF_CHAR, 24L, "1.0E+4>(m^2 s sr keV)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_N2"), CDF_CHAR, 15L, "1.0E+6>(m^3)^-1");
  if (status != CDF_OK) StatusHandler (status);
  status = CDFputAttrzEntry(file_id, CDFgetAttrNum(file_id, "SI_CONVERSION"), CDFvarNum(file_id, "SWA_HIS_V2"), CDF_CHAR, 13L, "1.0E+3>m s^-1");
  if (status != CDF_OK) StatusHandler (status);
  

  printf("filling in z variables...\n");

  //double SCET_Epoch; // CDF epoch value
       
  for(ii = 0; ii < HIS_Num_Records; ii++) // Write HIS data to CDF file
  {
     //SCET_Epoch = computeEPOCH(HIS_struct[ii].SCET[0], HIS_struct[ii].SCET[1], HIS_struct[ii].SCET[2],
     //			             HIS_struct[ii].SCET[3], HIS_struct[ii].SCET[4], HIS_struct[ii].SCET[5],HIS_struct[ii].SCET_milli);
     //printf("%f\n", HIS_struct[ii].eqtab[63]);
     status = CDFputzVarRecordData (file_id, HIS_EPOCH_num, ii, &HIS_struct[ii].epoch);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_SCET_num, ii, &HIS_struct[ii].SCET_seconds);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Ene_array_num, ii, &HIS_struct[ii].eqtab);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Ratio1_num, ii, &HIS_struct[ii].Ratio1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Ratio2_num, ii, &HIS_struct[ii].Ratio2);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Spectra1_num, ii, &HIS_struct[ii].Spectra1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Spectra2_num, ii, &HIS_struct[ii].Spectra2);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Quality_num, ii, &HIS_struct[0].QUAL_Value);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_QualityMask_num, ii, &HIS_struct[0].QUAL_Value);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_df1_num, ii, &HIS_struct[ii].df1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_dferror1_num, ii, &HIS_struct[ii].df1_err);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_n1_num, ii, &HIS_struct[ii].n1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_nerr1_num, ii, &HIS_struct[ii].n1_err);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_v1_num, ii, &HIS_struct[ii].v1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_t1_num, ii, &HIS_struct[ii].t1);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_df2_num, ii, &HIS_struct[ii].df2);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_dferror2_num, ii, &HIS_struct[ii].df2_err);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_n2_num, ii, &HIS_struct[ii].n2);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_nerr2_num, ii, &HIS_struct[ii].n2_err);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_v2_num, ii, &HIS_struct[ii].v2);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_t2_num, ii, &HIS_struct[ii].t2);
     if (status != CDF_OK) StatusHandler (status);


     //memcpy(HIS_Spectra1_Str, HIS_struct[ii].spectra1_str, 20);
     //printf("a%sa\n", HIS_Spectra1_Str);
     status = CDFputzVarRecordData (file_id, HIS_Species1_num, ii, &HIS_struct[ii].spectra1_str);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Species2_num, ii, &HIS_struct[ii].spectra2_str);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Ratio1_Species_num, ii, &HIS_struct[ii].ratio1_str);
     if (status != CDF_OK) StatusHandler (status);
     status = CDFputzVarRecordData (file_id, HIS_Ratio2_Species_num, ii, &HIS_struct[ii].ratio2_str);
     if (status != CDF_OK) StatusHandler (status);
  
  }

  printf("Closing CDF...\n");

/******************************************************************************
* Close CDF.
******************************************************************************/
  status = CDFcloseCDF (file_id);
  if (status != CDF_OK) StatusHandler (status);
  
}

/******************************************************************************
* Status handler function.
******************************************************************************/
int StatusHandler (CDFstatus status)
{
char message[CDF_ERRTEXT_LEN+1];

if (status < CDF_WARN) {
  printf ("An error has occurred, halting...\n");
  CDFgetStatusText (status, message);
  printf ("%s\n", message);
  //exit (-1);
}
else
  if (status < CDF_OK) {
    printf ("Warning, function may not have completed as expected...\n");
    CDFgetStatusText (status, message);
    printf ("%s\n", message);
  }
  else
    if (status > CDF_OK) {
      printf ("Function completed successfully, but be advised that...\n");
      CDFgetStatusText (status, message);
      printf ("%s\n", message);
    }       
//return ;
}
